Subject: Re: [PATCH v4 7/7] net: register debugfs file for net_device refcnt tracker

From: Jakub Kicinski <[email-masked]>
Date: Wed, 23 Apr 2025 17:32:31 -0700

On Wed, 23 Apr 2025 20:04:58 -0400 Jeff Layton wrote:
> On Wed, 2025-04-23 at 16:53 -0700, Jakub Kicinski wrote:
> > Names are not unique and IIUC debugfs is not namespaced.
> > How much naming the objects in a "user readable" fashion actually
> > matter? It'd be less churn to create some kind of "object class"
> > with a directory level named after what's already passed to
> > ref_tracker_dir_init() and then id the objects by the pointer value 
> > as sub-dirs of that?  
> 
> That sounds closer to what I had done originally. Andrew L. suggested
> the flat directory that this version represents. I'm fine with whatever
> hierarchy, but let's decide that before I respin again.

Sorry about that :(

> When I was tracking down net namespace leaks recently, it was very nice
> to have the inode number of the leaked netns's in the filenames. I
> would have probably had to grovel around with drgn to figure out the
> address if that weren't embedded in the name. I think we probably ought
> to leave it up to each subsystem how it names its files. The
> discriminators between different types of objects can vary wildly.
> 
> One thing that might be simpler is to make ref_tracker_dir_debugfs() a
> varargs function and allow passing in a format string and set of
> arguments for it. That might make things simpler for the callers.

Yes, cutting out the formatting in the callers would definitely 
be a win. Maybe that'd make the whole thing sufficiently palatable :)